(:
 :  eXide - web-based XQuery IDE
 :  
 :  Copyright (C) 2011 Wolfgang Meier
 :
 :  This program is free software: you can redistribute it and/or modify
 :  it under the terms of the GNU General Public License as published by
 :  the Free Software Foundation, either version 3 of the License, or
 :  (at your option) any later version.
 :
 :  This program is distributed in the hope that it will be useful,
 :  but WITHOUT ANY WARRANTY; without even the implied warranty of
 :  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 :  GNU General Public License for more details.
 :
 :  You should have received a copy of the GNU General Public License
 :  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 :)
xquery version "3.0";

declare option exist:serialize "method=json media-type=text/javascript";

declare function local:parse-message($msg as xs:string) {
    let $list := replace($msg, "^.*One of[^\{]*\{([^\}]*)\}.*$", "$1")
    let $alternatives := tokenize($list, "\s*,\s*")
    for $alternative in $alternatives
    return
        replace($alternative, '^"[^"]+":(.*)$', "$1")
};

declare function local:suggest($xml as xs:string, $row as xs:int) {
    let $data := util:parse($xml)
    let $marker := $data//exist:x-invalid-marker
    let $parent := node-name($marker/..)
    return
        <marker><parent>{$parent}</parent></marker>
};

let $xml := request:get-parameter("xml", ())
let $row := request:get-parameter("row", ())
return
    if (empty($row)) then
        (: validate only:)
    	try {
    		util:parse($xml)
    	} catch exerr:EXXQDY0002  {
    		$err:value
    	}
    else
        local:suggest($xml, $row)